################################################################################
#                           PROJECT INFORMATION                                #
#                              Name: MUTADOCK                                  #
#                           Author: Naisarg Patel                              #
#                                                                              #
#       Copyright (C) 2024 Naisarg Patel (https://github.com/naisarg14)        #
#                                                                              #
#          Project: https://github.com/naisarg14/mutadock                      #
#                                                                              #
#   This program is free software; you can redistribute it and/or modify it    #
#  under the terms of the GNU General Public License version 3 as published    #
#  by the Free Software Foundation.                                            #
#                                                                              #
#  This program is distributed in the hope that it will be useful, but         #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
#  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License    #
#  for more details.                                                           #
################################################################################


aa_dict = {
    "ALA": "A",
    "ARG": "R",
    "ASN": "N",
    "ASP": "D",
    "CYS": "C",
    "GLN": "Q",
    "GLU": "E",
    "GLY": "G",
    "HIS": "H",
    "ILE": "I",
    "LEU": "L",
    "LYS": "K",
    "MET": "M",
    "PHE": "F",
    "PRO": "P",
    "SER": "S",
    "THR": "T",
    "TRP": "W",
    "TYR": "Y",
    "VAL": "V",
}


def main():
    print("This is a dependency file for mutadock (https://github.com/naisarg14/mutadock) library's mutation module.")

def check_3(aa):
    aa = str(aa).strip().upper()
    if aa in aa_dict:
        return True
    return False

def check_1(aa):
    aa = str(aa).strip().upper()
    for a in aa_dict:
        if aa_dict[a] == aa:
            return True
    return False


def get_1(three):
    three = str(three).strip().upper()
    if check_1(three):
        return three
    elif three in aa_dict:
        return aa_dict[three]
    else:
        return None


def get_3(one):
    one = str(one).strip().upper()
    if check_3(one):
        return one
    for aa in aa_dict:
        if one == aa_dict[aa]:
            return aa
    return None


def get_dict():
    return aa_dict


def get_scfn_250():
    score_dict = {
        "ALA": {"ALA": 2, "ARG": -2, "ASN": 0, "ASP": 0, "CYS": -2, "GLN": 0, "GLU": 0, "GLY": 1, "HIS": -1, "ILE": -1, "LEU": -2, "LYS": -1, "MET": -1, "PHE": -3, "PRO": 1, "SER": 1, "THR": 1, "TRP": -6, "TYR": -3, "VAL": 0},
        "ARG": {"ALA": -2, "ARG": 6, "ASN": 0, "ASP": -1, "CYS": -4, "GLN": 1, "GLU": -1, "GLY": -3, "HIS": 2, "ILE": -2, "LEU": -3, "LYS": 3, "MET": 0, "PHE": -4, "PRO": 0, "SER": 0, "THR": -1, "TRP": 2, "TYR": -4, "VAL": -2},
        "ASN": {"ALA": 0, "ARG": 0, "ASN": 2, "ASP": 2, "CYS": -4, "GLN": 1, "GLU": 1, "GLY": 0, "HIS": 2, "ILE": -2, "LEU": -3, "LYS": 1, "MET": -2, "PHE": -3, "PRO": 0, "SER": 1, "THR": 0, "TRP": -4, "TYR": -2, "VAL": -2},
        "ASP": {"ALA": 0, "ARG": -1, "ASN": 2, "ASP": 4, "CYS": -5, "GLN": 2, "GLU": 3, "GLY": 1, "HIS": 1, "ILE": -2, "LEU": -4, "LYS": 0, "MET": -3, "PHE": -6, "PRO": -1, "SER": 0, "THR": 0, "TRP": -7, "TYR": -4, "VAL": -2},
        "CYS": {"ALA": -2, "ARG": -4, "ASN": -4, "ASP": -5, "CYS": 12, "GLN": -5, "GLU": -5, "GLY": -3, "HIS": -3, "ILE": -2, "LEU": -6, "LYS": -5, "MET": -5, "PHE": -4, "PRO": -3, "SER": 0, "THR": -2, "TRP": -8, "TYR": 0, "VAL": -2},
        "GLN": {"ALA": 0, "ARG": 1, "ASN": 1, "ASP": 2, "CYS": -5, "GLN": 4, "GLU": 2, "GLY": -1, "HIS": 3, "ILE": -2, "LEU": -2, "LYS": 1, "MET": -1, "PHE": -5, "PRO": 0, "SER": -1, "THR": -1, "TRP": -5, "TYR": -4, "VAL": -2},
        "GLU": {"ALA": 0, "ARG": -1, "ASN": 1, "ASP": 3, "CYS": -5, "GLN": 2, "GLU": 4, "GLY": 0, "HIS": 1, "ILE": -2, "LEU": -3, "LYS": 0, "MET": -2, "PHE": -5, "PRO": -1, "SER": 0, "THR": 0, "TRP": -7, "TYR": -4, "VAL": -2},
        "GLY": {"ALA": 1, "ARG": -3, "ASN": 0, "ASP": 1, "CYS": -3, "GLN": -1, "GLU": 0, "GLY": 5, "HIS": -2, "ILE": -3, "LEU": -4, "LYS": -2, "MET": -3, "PHE": -5, "PRO": 0, "SER": 1, "THR": 0, "TRP": -7, "TYR": -5, "VAL": -1},
        "HIS": {"ALA": -1, "ARG": 2, "ASN": 2, "ASP": 1, "CYS": -3, "GLN": 3, "GLU": 1, "GLY": -2, "HIS": 6, "ILE": -2, "LEU": -2, "LYS": 0, "MET": -2, "PHE": -2, "PRO": 0, "SER": -1, "THR": -1, "TRP": -3, "TYR": 0, "VAL": -2},
        "ILE": {"ALA": -1, "ARG": -2, "ASN": -2, "ASP": -2, "CYS": -2, "GLN": -2, "GLU": -2, "GLY": -3, "HIS": -2, "ILE": 5, "LEU": 2, "LYS": -2, "MET": 2, "PHE": 1, "PRO": -2, "SER": -1, "THR": 0, "TRP": -5, "TYR": -1, "VAL": 4},
        "LEU": {"ALA": -2, "ARG": -3, "ASN": -3, "ASP": -4, "CYS": -6, "GLN": -2, "GLU": -3, "GLY": -4, "HIS": -2, "ILE": 2, "LEU": 6, "LYS": -3, "MET": 4, "PHE": 2, "PRO": -3, "SER": -3, "THR": -2, "TRP": -2, "TYR": -1, "VAL": 2},
        "LYS": {"ALA": -1, "ARG": 3, "ASN": 1, "ASP": 0, "CYS": -5, "GLN": 1, "GLU": 0, "GLY": -2, "HIS": 0, "ILE": -2, "LEU": -3, "LYS": 5, "MET": 0, "PHE": -5, "PRO": -1, "SER": 0, "THR": 0, "TRP": -3, "TYR": -4, "VAL": -2},
        "MET": {"ALA": -1, "ARG": 0, "ASN": -2, "ASP": -3, "CYS": -5, "GLN": -1, "GLU": -2, "GLY": -3, "HIS": -2, "ILE": 2, "LEU": 4, "LYS": 0, "MET": 6, "PHE": 0, "PRO": -2, "SER": -2, "THR": -1, "TRP": -4, "TYR": -2, "VAL": 2},
        "PHE": {"ALA": -3, "ARG": -4, "ASN": -3, "ASP": -6, "CYS": -4, "GLN": -5, "GLU": -5, "GLY": -5, "HIS": -2, "ILE": 1, "LEU": 2, "LYS": -5, "MET": 0, "PHE": 9, "PRO": -5, "SER": -3, "THR": -3, "TRP": 0, "TYR": 7, "VAL": -1},
        "PRO": {"ALA": 1, "ARG": 0, "ASN": 0, "ASP": -1, "CYS": -3, "GLN": 0, "GLU": -1, "GLY": 0, "HIS": 0, "ILE": -2, "LEU": -3, "LYS": -1, "MET": -2, "PHE": -5, "PRO": 6, "SER": 1, "THR": 0, "TRP": -6, "TYR": -5, "VAL": -1},
        "SER": {"ALA": 1, "ARG": 0, "ASN": 1, "ASP": 0, "CYS": 0, "GLN": -1, "GLU": 0, "GLY": 1, "HIS": -1, "ILE": -1, "LEU": -3, "LYS": 0, "MET": -2, "PHE": -3, "PRO": 1, "SER": 2, "THR": 1, "TRP": -2, "TYR": -3, "VAL": -1},
        "THR": {"ALA": 1, "ARG": -1, "ASN": 0, "ASP": 0, "CYS": -2, "GLN": -1, "GLU": 0, "GLY": 0, "HIS": -1, "ILE": 0, "LEU": -2, "LYS": 0, "MET": -1, "PHE": -3, "PRO": 0, "SER": 1, "THR": 3, "TRP": -5, "TYR": -3, "VAL": 0},
        "TRP": {"ALA": -6, "ARG": 2, "ASN": -4, "ASP": -7, "CYS": -8, "GLN": -5, "GLU": -7, "GLY": -7, "HIS": -3, "ILE": -5, "LEU": -2, "LYS": -3, "MET": -4, "PHE": 0, "PRO": -6, "SER": -2, "THR": -5, "TRP": 17, "TYR": 0, "VAL": -6},
        "TYR": {"ALA": -3, "ARG": -4, "ASN": -2, "ASP": -4, "CYS": 0, "GLN": -4, "GLU": -4, "GLY": -5, "HIS": 0, "ILE": -1, "LEU": -1, "LYS": -4, "MET": -2, "PHE": 7, "PRO": -5, "SER": -3, "THR": -3, "TRP": 0, "TYR": 10, "VAL": -2},
        "VAL": {"ALA": 0, "ARG": -2, "ASN": -2, "ASP": -2, "CYS": -2, "GLN": -2, "GLU": -2, "GLY": -1, "HIS": -2, "ILE": 4, "LEU": 2, "LYS": -2, "MET": 2, "PHE": -1, "PRO": -1, "SER": -1, "THR": 0, "TRP": -6, "TYR": -2, "VAL": 4},
    }
    return score_dict


def get_scfn_1():
    score_dict = {
        "ALA": {
            "ALA": 9867,
            "ARG": 1,
            "ASN": 4,
            "ASP": 6,
            "CYS": 1,
            "GLN": 3,
            "GLU": 10,
            "GLY": 21,
            "HIS": 1,
            "ILE": 2,
            "LEU": 3,
            "LYS": 2,
            "MET": 1,
            "PHE": 1,
            "PRO": 13,
            "SER": 28,
            "THR": 22,
            "TRP": 0,
            "TYR": 1,
            "VAL": 13,
        },
        "ARG": {
            "ALA": 2,
            "ARG": 9913,
            "ASN": 1,
            "ASP": 0,
            "CYS": 1,
            "GLN": 9,
            "GLU": 0,
            "GLY": 1,
            "HIS": 8,
            "ILE": 2,
            "LEU": 1,
            "LYS": 37,
            "MET": 1,
            "PHE": 1,
            "PRO": 5,
            "SER": 11,
            "THR": 2,
            "TRP": 2,
            "TYR": 0,
            "VAL": 2,
        },
        "ASN": {
            "ALA": 9,
            "ARG": 1,
            "ASN": 9822,
            "ASP": 42,
            "CYS": 0,
            "GLN": 4,
            "GLU": 7,
            "GLY": 12,
            "HIS": 18,
            "ILE": 3,
            "LEU": 3,
            "LYS": 25,
            "MET": 0,
            "PHE": 1,
            "PRO": 2,
            "SER": 34,
            "THR": 13,
            "TRP": 0,
            "TYR": 3,
            "VAL": 1,
        },
        "ASP": {
            "ALA": 10,
            "ARG": 0,
            "ASN": 36,
            "ASP": 9859,
            "CYS": 0,
            "GLN": 5,
            "GLU": 56,
            "GLY": 11,
            "HIS": 3,
            "ILE": 1,
            "LEU": 0,
            "LYS": 6,
            "MET": 0,
            "PHE": 0,
            "PRO": 1,
            "SER": 7,
            "THR": 4,
            "TRP": 0,
            "TYR": 0,
            "VAL": 1,
        },
        "CYS": {
            "ALA": 3,
            "ARG": 1,
            "ASN": 0,
            "ASP": 0,
            "CYS": 9973,
            "GLN": 0,
            "GLU": 0,
            "GLY": 1,
            "HIS": 1,
            "ILE": 2,
            "LEU": 0,
            "LYS": 0,
            "MET": 0,
            "PHE": 0,
            "PRO": 1,
            "SER": 11,
            "THR": 1,
            "TRP": 0,
            "TYR": 3,
            "VAL": 3,
        },
        "GLN": {
            "ALA": 8,
            "ARG": 10,
            "ASN": 4,
            "ASP": 6,
            "CYS": 0,
            "GLN": 9876,
            "GLU": 35,
            "GLY": 3,
            "HIS": 20,
            "ILE": 1,
            "LEU": 6,
            "LYS": 12,
            "MET": 2,
            "PHE": 0,
            "PRO": 8,
            "SER": 4,
            "THR": 3,
            "TRP": 0,
            "TYR": 0,
            "VAL": 2,
        },
        "GLU": {
            "ALA": 17,
            "ARG": 0,
            "ASN": 6,
            "ASP": 53,
            "CYS": 0,
            "GLN": 27,
            "GLU": 9865,
            "GLY": 7,
            "HIS": 1,
            "ILE": 2,
            "LEU": 1,
            "LYS": 7,
            "MET": 0,
            "PHE": 0,
            "PRO": 3,
            "SER": 6,
            "THR": 2,
            "TRP": 0,
            "TYR": 1,
            "VAL": 2,
        },
        "GLY": {
            "ALA": 21,
            "ARG": 0,
            "ASN": 6,
            "ASP": 6,
            "CYS": 0,
            "GLN": 1,
            "GLU": 4,
            "GLY": 9935,
            "HIS": 0,
            "ILE": 0,
            "LEU": 1,
            "LYS": 2,
            "MET": 0,
            "PHE": 1,
            "PRO": 2,
            "SER": 16,
            "THR": 2,
            "TRP": 0,
            "TYR": 0,
            "VAL": 3,
        },
        "HIS": {
            "ALA": 2,
            "ARG": 10,
            "ASN": 21,
            "ASP": 4,
            "CYS": 1,
            "GLN": 23,
            "GLU": 2,
            "GLY": 1,
            "HIS": 9912,
            "ILE": 0,
            "LEU": 4,
            "LYS": 2,
            "MET": 0,
            "PHE": 2,
            "PRO": 5,
            "SER": 2,
            "THR": 1,
            "TRP": 0,
            "TYR": 4,
            "VAL": 3,
        },
        "ILE": {
            "ALA": 6,
            "ARG": 3,
            "ASN": 3,
            "ASP": 1,
            "CYS": 1,
            "GLN": 1,
            "GLU": 3,
            "GLY": 0,
            "HIS": 0,
            "ILE": 9872,
            "LEU": 22,
            "LYS": 4,
            "MET": 5,
            "PHE": 8,
            "PRO": 1,
            "SER": 2,
            "THR": 11,
            "TRP": 0,
            "TYR": 1,
            "VAL": 57,
        },
        "LEU": {
            "ALA": 4,
            "ARG": 1,
            "ASN": 1,
            "ASP": 0,
            "CYS": 0,
            "GLN": 3,
            "GLU": 1,
            "GLY": 1,
            "HIS": 1,
            "ILE": 9,
            "LEU": 9947,
            "LYS": 1,
            "MET": 8,
            "PHE": 6,
            "PRO": 2,
            "SER": 1,
            "THR": 2,
            "TRP": 0,
            "TYR": 1,
            "VAL": 11,
        },
        "LYS": {
            "ALA": 2,
            "ARG": 19,
            "ASN": 13,
            "ASP": 3,
            "CYS": 0,
            "GLN": 6,
            "GLU": 4,
            "GLY": 2,
            "HIS": 1,
            "ILE": 2,
            "LEU": 2,
            "LYS": 9926,
            "MET": 4,
            "PHE": 0,
            "PRO": 2,
            "SER": 7,
            "THR": 8,
            "TRP": 0,
            "TYR": 0,
            "VAL": 1,
        },
        "MET": {
            "ALA": 6,
            "ARG": 4,
            "ASN": 0,
            "ASP": 0,
            "CYS": 0,
            "GLN": 4,
            "GLU": 1,
            "GLY": 1,
            "HIS": 0,
            "ILE": 12,
            "LEU": 45,
            "LYS": 20,
            "MET": 9874,
            "PHE": 4,
            "PRO": 1,
            "SER": 4,
            "THR": 6,
            "TRP": 0,
            "TYR": 0,
            "VAL": 17,
        },
        "PHE": {
            "ALA": 2,
            "ARG": 1,
            "ASN": 1,
            "ASP": 0,
            "CYS": 0,
            "GLN": 0,
            "GLU": 0,
            "GLY": 1,
            "HIS": 2,
            "ILE": 7,
            "LEU": 13,
            "LYS": 0,
            "MET": 1,
            "PHE": 9946,
            "PRO": 1,
            "SER": 3,
            "THR": 1,
            "TRP": 1,
            "TYR": 21,
            "VAL": 1,
        },
        "PRO": {
            "ALA": 22,
            "ARG": 4,
            "ASN": 2,
            "ASP": 1,
            "CYS": 1,
            "GLN": 6,
            "GLU": 3,
            "GLY": 3,
            "HIS": 3,
            "ILE": 0,
            "LEU": 3,
            "LYS": 3,
            "MET": 0,
            "PHE": 0,
            "PRO": 9926,
            "SER": 17,
            "THR": 5,
            "TRP": 0,
            "TYR": 0,
            "VAL": 3,
        },
        "SER": {
            "ALA": 35,
            "ARG": 6,
            "ASN": 20,
            "ASP": 5,
            "CYS": 5,
            "GLN": 2,
            "GLU": 4,
            "GLY": 21,
            "HIS": 1,
            "ILE": 1,
            "LEU": 1,
            "LYS": 8,
            "MET": 1,
            "PHE": 2,
            "PRO": 12,
            "SER": 9840,
            "THR": 32,
            "TRP": 1,
            "TYR": 1,
            "VAL": 2,
        },
        "THR": {
            "ALA": 32,
            "ARG": 1,
            "ASN": 9,
            "ASP": 3,
            "CYS": 1,
            "GLN": 2,
            "GLU": 2,
            "GLY": 3,
            "HIS": 1,
            "ILE": 7,
            "LEU": 3,
            "LYS": 11,
            "MET": 2,
            "PHE": 1,
            "PRO": 4,
            "SER": 38,
            "THR": 9871,
            "TRP": 0,
            "TYR": 1,
            "VAL": 10,
        },
        "TRP": {
            "ALA": 0,
            "ARG": 8,
            "ASN": 1,
            "ASP": 0,
            "CYS": 0,
            "GLN": 0,
            "GLU": 0,
            "GLY": 0,
            "HIS": 1,
            "ILE": 0,
            "LEU": 4,
            "LYS": 0,
            "MET": 0,
            "PHE": 3,
            "PRO": 0,
            "SER": 5,
            "THR": 0,
            "TRP": 9976,
            "TYR": 2,
            "VAL": 0,
        },
        "TYR": {
            "ALA": 2,
            "ARG": 0,
            "ASN": 4,
            "ASP": 0,
            "CYS": 3,
            "GLN": 0,
            "GLU": 1,
            "GLY": 0,
            "HIS": 4,
            "ILE": 1,
            "LEU": 2,
            "LYS": 1,
            "MET": 0,
            "PHE": 28,
            "PRO": 0,
            "SER": 2,
            "THR": 2,
            "TRP": 1,
            "TYR": 9945,
            "VAL": 2,
        },
        "VAL": {
            "ALA": 18,
            "ARG": 1,
            "ASN": 1,
            "ASP": 1,
            "CYS": 2,
            "GLN": 1,
            "GLU": 2,
            "GLY": 5,
            "HIS": 1,
            "ILE": 33,
            "LEU": 15,
            "LYS": 1,
            "MET": 4,
            "PHE": 0,
            "PRO": 2,
            "SER": 2,
            "THR": 9,
            "TRP": 0,
            "TYR": 1,
            "VAL": 9901,
        },
    }
    return score_dict


if __name__ == "__main__":
    main()
